## gringo 5.2.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)

file(READ "libclingo/clingo.h" clingoh)
string(REGEX MATCH "#define CLINGO_VERSION \"([^\"]*)\"" clingov ${clingoh})

project(CLINGO VERSION "${CMAKE_MATCH_1}" LANGUAGES C CXX)
if (POLICY CMP0063)
    cmake_policy(SET CMP0063 NEW)
endif()
if (NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
	message(STATUS "No build type selected - using 'Release'")
	set(CMAKE_BUILD_TYPE "Release")
endif()

include(GNUInstallDirs)
include(CMakeDependentOption)
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
include(clingo_functions)

# Enable folders in IDEs like Visual Studio
set_property(GLOBAL PROPERTY USE_FOLDERS ON)

set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

option(CLINGO_BUILD_WEB         "enable web target"             OFF)
option(CLINGO_BUILD_STATIC      "do not build shared libraries" OFF)
option(CLINGO_BUILD_WITH_PYTHON "enable python support"          ON)
option(CLINGO_BUILD_WITH_LUA    "enable lua support"             ON)
option(CLINGO_BUILD_TESTS       "build tests"                   OFF)
option(CLINGO_BUILD_EXAMPLES    "build examples"                OFF)
option(CLINGO_BUILD_APPS        "build applications"             ON)
option(CLINGO_MANAGE_RPATH      "set rpath if not installed into system directory" ON)

CMAKE_DEPENDENT_OPTION(CLINGO_REQUIRE_PYTHON   "fail if python support not found" OFF "CLINGO_BUILD_WITH_PYTHON" OFF)
CMAKE_DEPENDENT_OPTION(CLINGO_REQUIRE_LUA      "fail if lua support not found"    OFF "CLINGO_BUILD_WITH_LUA"    OFF)
CMAKE_DEPENDENT_OPTION(CLINGO_BUILD_SHARED     "build clingo library shared"      ON  "NOT CLINGO_BUILD_STATIC"  OFF)
CMAKE_DEPENDENT_OPTION(CLINGO_BUILD_PY_SHARED  "build pyclingo library shared"    OFF "NOT CLINGO_BUILD_STATIC"  OFF)
CMAKE_DEPENDENT_OPTION(CLINGO_BUILD_LUA_SHARED "build luaclingo library shared"   OFF "NOT CLINGO_BUILD_STATIC"  OFF)

option(PYCLINGO_USER_INSTALL "install the python module in the user's site directory" ON)
CMAKE_DEPENDENT_OPTION(PYCLINGO_USE_INSTALL_PREFIX "install the python module under the install prefix" OFF "NOT PYCLINGO_USER_INSTALL" OFF)

set(CLINGO_CLINGOPATH "" CACHE STRING "global search directories for clingo's include statement")

mark_as_advanced(CLINGO_BUILD_WEB)
mark_as_advanced(CLINGO_BUILD_STATIC)
mark_as_advanced(CLINGO_BUILD_SHARED)
mark_as_advanced(CLINGO_BUILD_PY_SHARED)
mark_as_advanced(CLINGO_BUILD_LUA_SHARED)

# workaround to set custom ar and ranlib
if (CLINGO_CMAKE_AR)
    set(CMAKE_AR "${CLINGO_CMAKE_AR}")
    set(CMAKE_CXX_ARCHIVE_CREATE "<CMAKE_AR> qc <TARGET> <LINK_FLAGS> <OBJECTS>")
    set(CMAKE_C_ARCHIVE_CREATE "<CMAKE_AR> qc <TARGET> <LINK_FLAGS> <OBJECTS>")
endif()
if (CLINGO_CMAKE_RANLIB)
    set(CMAKE_RANLIB "${CLINGO_CMAKE_RANLIB}")
    set(CMAKE_CXX_ARCHIVE_FINISH "<CMAKE_RANLIB> <TARGET>")
    set(CMAKE_C_ARCHIVE_FINISH "<CMAKE_RANLIB> <TARGET>")
endif()

if (CLINGO_MANAGE_RPATH)
    set(CMAKE_SKIP_BUILD_RPATH FALSE)
    set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
    set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
    set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
    list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/lib" isSystemDir)
    if ("${isSystemDir}" STREQUAL "-1")
        set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
    endif()
endif()

if (CLINGO_BUILD_WEB)
    unset(CMAKE_C_USE_RESPONSE_FILE_FOR_LIBRARIES)
    unset(CMAKE_CXX_USE_RESPONSE_FILE_FOR_LIBRARIES)
    unset(CMAKE_C_USE_RESPONSE_FILE_FOR_OBJECTS)
    unset(CMAKE_CXX_USE_RESPONSE_FILE_FOR_OBJECTS)
    unset(CMAKE_C_USE_RESPONSE_FILE_FOR_INCLUDES)
    unset(CMAKE_CXX_USE_RESPONSE_FILE_FOR_INCLUDES)
endif()

if (NOT CMAKE_ARCHIVE_OUTPUT_DIRECTORY)
    set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
endif()
if (NOT CMAKE_LIBRARY_OUTPUT_DIRECTORY)
    set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
endif()
if (NOT CMAKE_RUNTIME_OUTPUT_DIRECTORY)
    set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
endif()
if (NOT CMAKE_IMPORT_LIBRARY_PREFIX)
    set(CMAKE_IMPORT_LIBRARY_PREFIX import_)
endif()

# NOTE: searching for the interpreter first increases the chance
#       that searching for the python libraries finds the matching libraries for the default python interpreter
#       python is also used to run the tests
find_package(PythonInterp)
if (CLINGO_BUILD_WITH_PYTHON)
    if (CLINGO_REQUIRE_PYTHON)
        find_package(PythonLibs REQUIRED)
    else()
        find_package(PythonLibs)
    endif()
    if(PYTHONLIBS_FOUND)
        add_library(Python::Python INTERFACE IMPORTED)
        set_property(TARGET Python::Python PROPERTY INTERFACE_LINK_LIBRARIES "${PYTHON_LIBRARIES}")
        set_property(TARGET Python::Python PROPERTY INTERFACE_INCLUDE_DIRECTORIES "${PYTHON_INCLUDE_DIRS}")
    endif()
endif()
if (CLINGO_BUILD_WITH_LUA)
    if (CLINGO_REQUIRE_LUA)
        find_package(Lua REQUIRED)
    else()
        find_package(Lua)
    endif()
    if(LUA_FOUND)
        add_library(Lua::Lua INTERFACE IMPORTED)
        set_property(TARGET Lua::Lua PROPERTY INTERFACE_LINK_LIBRARIES "${LUA_LIBRARIES}")
        set_property(TARGET Lua::Lua PROPERTY INTERFACE_INCLUDE_DIRECTORIES "${LUA_INCLUDE_DIR}")
    endif()
endif()
find_package(BISON "2.5")
find_package(RE2C "0.13")

if (POLICY CMP0063 AND (CLINGO_BUILD_SHARED OR PYTHONLIBS_FOUND OR LUA_FOUND))
    set(CMAKE_CXX_VISIBILITY_PRESET hidden)
    set(CMAKE_C_VISIBILITY_PRESET hidden)
endif()

enable_testing()

# NOTE: assumes that submodule has been initialized
set(clingo_library_targets libclingo libgringo libpotassco libclasp libreify)
set(CLASP_BUILD_APP ${CLINGO_BUILD_APPS} CACHE BOOL "")
add_subdirectory(clasp)
add_subdirectory(libreify)
add_subdirectory(libgringo)
add_subdirectory(libclingo)
if (PYTHONLIBS_FOUND)
    add_subdirectory(libpyclingo)
    list(APPEND clingo_library_targets libpyclingo)
else()
    add_library(libpyclingo INTERFACE IMPORTED)
endif()
if (LUA_FOUND)
    add_subdirectory(libluaclingo)
    list(APPEND clingo_library_targets libluaclingo)
else()
    add_library(libluaclingo INTERFACE IMPORTED)
endif()
if (CLINGO_BUILD_APPS)
    add_subdirectory(app/reify)
    add_subdirectory(app/gringo)
    add_subdirectory(app/clingo)
endif()
if (CLINGO_BUILD_EXAMPLES)
    add_subdirectory(examples/c)
    add_subdirectory(examples/cc)
endif()
if (NOT CLINGO_BUILD_STATIC AND PYTHONLIBS_FOUND)
    add_subdirectory(app/pyclingo)
endif()
if (NOT CLINGO_BUILD_STATIC AND LUA_FOUND)
    add_subdirectory(app/luaclingo)
endif()
if (CLINGO_BUILD_WEB)
    add_subdirectory(app/web)
endif()
if (NOT CLINGO_BUILD_STATIC AND (CLINGO_BUILD_SHARED OR PYTHONLIBS_FOUND OR LUA_FOUND))
    foreach(target ${clingo_library_targets})
        set_target_properties(${target} PROPERTIES POSITION_INDEPENDENT_CODE ON)
    endforeach()
endif()

=== clasp/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)
project(CLASP VERSION 3.3.3 LANGUAGES CXX)
# Enable folders in IDEs like Visual Studio
set_property(GLOBAL PROPERTY USE_FOLDERS ON)
if (POLICY CMP0063)
	cmake_policy(SET CMP0063 NEW)
endif()
if (NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
	message(STATUS "No build type selected - using 'Release'")
	set(CMAKE_BUILD_TYPE "Release")
endif()
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

include(GNUInstallDirs)

# Configuration options
option(CLASP_BUILD_APP          "whether or not to build the clasp application" ON)
option(CLASP_BUILD_STATIC       "whether or not to link statically (if supported)" OFF)
option(CLASP_BUILD_TESTS        "whether or not to build clasp unit tests" OFF)
option(CLASP_BUILD_EXAMPLES     "whether or not to build examples" OFF)
option(CLASP_BUILD_WITH_THREADS "whether or not to build clasp with threading support (requires C++11)" ON)
option(CLASP_INSTALL_LIB        "whether or not to install libclasp" OFF)

if (NOT MSVC)
	if (NOT CMAKE_ARCHIVE_OUTPUT_DIRECTORY)
		set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
	endif()
	if (NOT CMAKE_LIBRARY_OUTPUT_DIRECTORY)
		set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
	endif()
	if (NOT CMAKE_RUNTIME_OUTPUT_DIRECTORY)
		set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
	endif()
else()
	set(VC_RELEASE_LINK_OPTIONS /LTCG)
	SET(CMAKE_EXE_LINKER_FLAGS_RELEASE    "${CMAKE_EXE_LINKER_FLAGS_RELEASE}    ${VC_RELEASE_LINK_OPTIONS}")
	SET(CMAKE_MODULE_LINKER_FLAGS_RELEASE "${CMAKE_MODULE_LINKER_FLAGS_RELEASE} ${VC_RELEASE_LINK_OPTIONS}")
	SET(CMAKE_SHARED_LINKER_FLAGS_RELEASE "${CMAKE_SHARED_LINKER_FLAGS_RELEASE} ${VC_RELEASE_LINK_OPTIONS}")
	SET(CMAKE_STATIC_LINKER_FLAGS_RELEASE "${CMAKE_STATIC_LINKER_FLAGS_RELEASE} ${VC_RELEASE_LINK_OPTIONS}")
	if (CLASP_BUILD_STATIC)
		# force static runtime
		string(REGEX REPLACE "/MD" "/MT" CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE}")
	endif()
endif()
set(clasp_include_dest "clasp-${CLASP_VERSION}")
set(clasp_library_dest "clasp-${CLASP_VERSION}")
set(cmake_dest         "clasp-${CLASP_VERSION}/cmake")

if (CLASP_INSTALL_LIB AND NOT CMAKE_INSTALL_LIBDIR)
	message(STATUS "LIBDIR no set - using lib")
	set(CMAKE_INSTALL_LIBDIR lib)
endif()


# C++11 is required for building with threads
if (CLASP_BUILD_WITH_THREADS)
	set(CMAKE_CXX_STANDARD 11)
	set(CMAKE_CXX_STANDARD_REQUIRED ON)
	set(CMAKE_CXX_EXTENSIONS OFF)
	# some versions of findThreads will fail if C is not enabled
	enable_language(C)
	find_package(Threads REQUIRED)

	# Add libatomic if necessary
	if (CMAKE_CXX_COMPILER_ID MATCHES "Clang" AND CMAKE_USE_PTHREADS_INIT)
		include (CheckCXXSourceCompiles)
		set (OLD_CMAKE_REQUIRED_FLAGS ${CMAKE_REQUIRED_FLAGS})
		set (OLD_CMAKE_REQUIRED_LIBRARIES ${CMAKE_REQUIRED_LIBRARIES})
		list(APPEND CMAKE_REQUIRED_FLAGS "-std=c++11")
		list(APPEND CMAKE_REQUIRED_LIBRARIES Threads::Threads)
		check_cxx_source_compiles("
#include <atomic>
#include <cstdint>
std::atomic<uint64_t> x (0);
int main() {
	uint64_t i = x.load(std::memory_order_relaxed);
	return 0;
}
" CLASP_HAS_WORKING_LIBATOMIC)
		set (CMAKE_REQUIRED_FLAGS ${OLD_CMAKE_REQUIRED_FLAGS})
		set (CMAKE_REQUIRED_LIBRARIES ${OLD_CMAKE_REQUIRED_LIBRARIES})
		if (NOT CLASP_HAS_WORKING_LIBATOMIC)
			check_library_exists(atomic __atomic_fetch_add_4 "" CLASP_HAS_LIBATOMIC)
			if (CLASP_HAS_LIBATOMIC)
				set_property(TARGET Threads::Threads APPEND PROPERTY INTERFACE_LINK_LIBRARIES "atomic")
			endif()
		endif()
	endif()
endif()

# Check for and optionally build external dependency
find_package(potassco 1.0 QUIET CONFIG)
if (NOT potassco_FOUND)
	if (NOT EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/libpotassco/CMakeLists.txt)
		message(STATUS "Potassco is not installed - fetching submodule")
		execute_process(COMMAND git submodule update --init WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} OUTPUT_QUIET)
	else()
		message(STATUS "Potassco is not installed - using local copy")
	endif()
	set(LIB_POTASSCO_BUILD_APP   ${CLASP_BUILD_APP}   CACHE BOOL "")
	set(LIB_POTASSCO_INSTALL_LIB ${CLASP_INSTALL_LIB} CACHE BOOL "")
	add_subdirectory(libpotassco)
endif()

# Build clasp library
add_subdirectory(src)

# Build optional targets
if(CLASP_BUILD_TESTS)
	enable_testing()
	add_subdirectory(tests)
endif()
# optional doc target
find_package(Doxygen)
if(DOXYGEN_FOUND)
	set(doxyfile "${CMAKE_CURRENT_SOURCE_DIR}/doc/api/clasp.doxy")
	add_custom_target(doc_clasp
		COMMAND ${DOXYGEN_EXECUTABLE} ${doxyfile}
		WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/doc/api"
		COMMENT "Generating documentation..."
		VERBATIM)
	set_target_properties(doc_clasp PROPERTIES FOLDER doc)
endif()

if(CLASP_BUILD_APP)
	add_subdirectory(app)
endif()

if(CLASP_BUILD_EXAMPLES)
	add_subdirectory(examples)
endif()

# Export
configure_file(cmake/clasp-config-version.cmake.in
	${CMAKE_CURRENT_BINARY_DIR}/clasp-config-version.cmake
	@ONLY)

configure_file(cmake/clasp-config.cmake.in
	${CMAKE_CURRENT_BINARY_DIR}/clasp-config.cmake
	@ONLY)

if (CLASP_INSTALL_LIB)
	install(FILES ${CMAKE_CURRENT_BINARY_DIR}/clasp-config.cmake ${CMAKE_CURRENT_BINARY_DIR}/clasp-config-version.cmake
	  DESTINATION "${CMAKE_INSTALL_LIBDIR}/${cmake_dest}")
	install(EXPORT clasp DESTINATION "${CMAKE_INSTALL_LIBDIR}/${cmake_dest}")
endif()

=== libclingo/CMakeLists.txt ===
# [[[header: .
set(ide_header_group "Header Files")
set(header-group
    "${CMAKE_CURRENT_SOURCE_DIR}/clingo.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/clingo.hh")
source_group("${ide_header_group}" FILES ${header-group})
set(header-group-clingo
    "${CMAKE_CURRENT_SOURCE_DIR}/clingo/ast.hh"
    "${CMAKE_CURRENT_SOURCE_DIR}/clingo/clingo_app.hh"
    "${CMAKE_CURRENT_SOURCE_DIR}/clingo/clingocontrol.hh"
    "${CMAKE_CURRENT_SOURCE_DIR}/clingo/control.hh"
    "${CMAKE_CURRENT_SOURCE_DIR}/clingo/incmode.hh"
    "${CMAKE_CURRENT_SOURCE_DIR}/clingo/script.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/clingo/scripts.hh")
source_group("${ide_header_group}\\clingo" FILES ${header-group-clingo})
set(header
    ${header-group}
    ${header-group-clingo})
# ]]]
# [[[source: src
set(ide_source_group "Source Files")
set(source-group
    "${CMAKE_CURRENT_SOURCE_DIR}/src/ast.cc"
    "${CMAKE_CURRENT_SOURCE_DIR}/src/clingo_app.cc"
    "${CMAKE_CURRENT_SOURCE_DIR}/src/clingocontrol.cc"
    "${CMAKE_CURRENT_SOURCE_DIR}/src/control.cc"
    "${CMAKE_CURRENT_SOURCE_DIR}/src/gringo_app.cc"
    "${CMAKE_CURRENT_SOURCE_DIR}/src/incmode.cc"
    "${CMAKE_CURRENT_SOURCE_DIR}/src/scripts.cc")
source_group("${ide_source_group}" FILES ${source-group})
set(source
    ${source-group})
# ]]]

list(APPEND header "${CLASP_SOURCE_DIR}/app/clasp_app.h")
list(APPEND source "${CLASP_SOURCE_DIR}/app/clasp_app.cpp")

if (CLINGO_BUILD_SHARED)
    set(clingo_lib_type SHARED)
else()
    set(clingo_lib_type STATIC)
endif()

add_library(libclingo ${clingo_lib_type} ${header} ${source})
target_link_libraries(libclingo PRIVATE libgringo libclasp)
target_include_directories(libclingo
    PUBLIC
    "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>"
    PRIVATE
    "$<BUILD_INTERFACE:${CLASP_SOURCE_DIR}/app>")
target_compile_definitions(libclingo PRIVATE CLINGO_BUILD_LIBRARY)
if (NOT CLINGO_BUILD_SHARED)
    target_compile_definitions(libclingo PUBLIC CLINGO_NO_VISIBILITY)
else()
    set_target_properties(libclingo PROPERTIES SOVERSION 1 VERSION 1.0)
    install(TARGETS libclingo
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
    install(FILES
        "${CMAKE_CURRENT_SOURCE_DIR}/clingo.hh"
        "${CMAKE_CURRENT_SOURCE_DIR}/clingo.h"
        DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
endif()
if(MSVC)
    target_compile_definitions(libclingo PRIVATE _SCL_SECURE_NO_WARNINGS)
endif()
set_target_properties(libclingo PROPERTIES
    OUTPUT_NAME clingo
    FOLDER lib)

if (CLINGO_BUILD_TESTS)
    add_subdirectory(tests)
endif()

=== libpyclingo/CMakeLists.txt ===
# [[[source: .
set(ide_source_group "Source Files")
set(source-group
    "${CMAKE_CURRENT_SOURCE_DIR}/pyclingo.cc"
    "${CMAKE_CURRENT_SOURCE_DIR}/pyclingo.h")
source_group("${ide_source_group}" FILES ${source-group})
set(source
    ${source-group})
# ]]]

if (CLINGO_BUILD_PY_SHARED)
    set(pyclingo_lib_type SHARED)
else()
    set(pyclingo_lib_type STATIC)
endif()

add_library(libpyclingo ${pyclingo_lib_type} ${source})
target_link_libraries(libpyclingo PUBLIC libclingo PRIVATE Python::Python)
target_include_directories(libpyclingo PUBLIC
    "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>")
target_compile_definitions(libpyclingo PRIVATE PYCLINGO_BUILD_LIBRARY PUBLIC CLINGO_WITH_PYTHON)
if (NOT CLINGO_BUILD_PY_SHARED)
    target_compile_definitions(libpyclingo PUBLIC PYCLINGO_NO_VISIBILITY)
else()
    set_target_properties(libpyclingo PROPERTIES SOVERSION 1 VERSION 1.0)
    install(TARGETS libpyclingo
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
endif()
set_target_properties(libpyclingo PROPERTIES
    OUTPUT_NAME pyclingo
    FOLDER lib)

=== app/clingo/CMakeLists.txt ===
# [[[source: .
set(ide_source_group "Source Files")
set(source-group
    "${CMAKE_CURRENT_SOURCE_DIR}/main.cc")
source_group("${ide_source_group}" FILES ${source-group})
set(source
    ${source-group})
# ]]]

add_executable(clingo ${header} ${source})
target_link_libraries(clingo PRIVATE libclingo libpyclingo libluaclingo)
set_target_properties(clingo PROPERTIES FOLDER exe)

install(TARGETS clingo RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

if (CLINGO_BUILD_TESTS)
    add_subdirectory(tests)
endif()

=== app/luaclingo/CMakeLists.txt ===
# [[[source: .
set(ide_source_group "Source Files")
set(source-group
    "${CMAKE_CURRENT_SOURCE_DIR}/main.cc")
source_group("${ide_source_group}" FILES ${source-group})
set(source
    ${source-group})
# ]]]

add_library(luaclingo SHARED ${source})
target_link_libraries(luaclingo PRIVATE libluaclingo)
set_target_properties(luaclingo PROPERTIES
    FOLDER lib
    OUTPUT_NAME clingo
    PREFIX "")
target_include_directories(luaclingo PRIVATE ${LUA_INCLUDE_DIR})
if (CMAKE_RUNTIME_OUTPUT_DIRECTORY)
    set_target_properties(luaclingo PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/lua)
endif()
if (CMAKE_LIBRARY_OUTPUT_DIRECTORY)
    set_target_properties(luaclingo PROPERTIES LIBRARY_OUTPUT_DIRECTORY ${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/lua)
endif()
if (CMAKE_ARCHIVE_OUTPUT_DIRECTORY)
    set_target_properties(luaclingo PROPERTIES ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_ARCHIVE_OUTPUT_DIRECTORY}/lua)
endif()

if (LUACLINGO_SUFFIX)
    set_target_properties(luaclingo PROPERTIES
        SUFFIX ${LUACLINGO_SUFFIX})
endif()

if (LUACLINGO_INSTALL_DIR)
    install(TARGETS luaclingo
        RUNTIME DESTINATION ${LUACLINGO_INSTALL_DIR}
        LIBRARY DESTINATION ${LUACLINGO_INSTALL_DIR})
endif()

=== app/pyclingo/CMakeLists.txt ===
# [[[source: .
set(ide_source_group "Source Files")
set(source-group
    "${CMAKE_CURRENT_SOURCE_DIR}/main.cc")
source_group("${ide_source_group}" FILES ${source-group})
set(source
    ${source-group})
# ]]]

if (NOT PYCLINGO_INSTALL_DIR AND PYTHON_EXECUTABLE)
    if (PYCLINGO_USER_INSTALL)
        execute_process(COMMAND ${PYTHON_EXECUTABLE} -m site --user-site OUTPUT_VARIABLE PYCLINGO_INSTALL_DIR OUTPUT_STRIP_TRAILING_WHITESPACE)
    elseif(PYCLINGO_USE_INSTALL_PREFIX)
        execute_process(COMMAND ${PYTHON_EXECUTABLE} ${CLINGO_SOURCE_DIR}/cmake/python-site.py prefix "${CMAKE_INSTALL_PREFIX}" OUTPUT_VARIABLE PYCLINGO_INSTALL_DIR OUTPUT_STRIP_TRAILING_WHITESPACE)
    else()
        execute_process(COMMAND ${PYTHON_EXECUTABLE} ${CLINGO_SOURCE_DIR}/cmake/python-site.py prefix OUTPUT_VARIABLE PYCLINGO_INSTALL_DIR OUTPUT_STRIP_TRAILING_WHITESPACE)
    endif()
endif()

if (NOT PYCLINGO_SUFFIX)
    if (PYTHON_EXECUTABLE)
        execute_process(COMMAND ${PYTHON_EXECUTABLE} ${CLINGO_SOURCE_DIR}/cmake/python-site.py suffix OUTPUT_VARIABLE PYCLINGO_SUFFIX OUTPUT_STRIP_TRAILING_WHITESPACE)
    else()
        if (CYGWIN)
            set(PYCLINGO_SUFFIX ".dll")
        elseif (UNIX)
            set(PYCLINGO_SUFFIX ".so")
        else()
            set(PYCLINGO_SUFFIX ".pyd")
        endif()
    endif()
endif()

add_library(pyclingo SHARED ${source})
target_link_libraries(pyclingo PRIVATE libpyclingo)
set_target_properties(pyclingo PROPERTIES
    FOLDER lib
    OUTPUT_NAME clingo
    SUFFIX ${PYCLINGO_SUFFIX}
    PREFIX "")
target_include_directories(pyclingo PRIVATE ${PYTHON_INCLUDE_DIRS})
if (CMAKE_RUNTIME_OUTPUT_DIRECTORY)
    set_target_properties(pyclingo PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/python)
endif()
if (CMAKE_LIBRARY_OUTPUT_DIRECTORY)
    set_target_properties(pyclingo PROPERTIES LIBRARY_OUTPUT_DIRECTORY ${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/python)
endif()
if (CMAKE_ARCHIVE_OUTPUT_DIRECTORY)
    set_target_properties(pyclingo PROPERTIES ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_ARCHIVE_OUTPUT_DIRECTORY}/python)
endif()

if (PYCLINGO_INSTALL_DIR)
    install(TARGETS pyclingo
        RUNTIME DESTINATION ${PYCLINGO_INSTALL_DIR}
        LIBRARY DESTINATION ${PYCLINGO_INSTALL_DIR})
endif()

=== app/reify/CMakeLists.txt ===
# [[[source: .
set(ide_source_group "Source Files")
set(source-group
    "${CMAKE_CURRENT_SOURCE_DIR}/main.cc")
source_group("${ide_source_group}" FILES ${source-group})
set(source
    ${source-group})
# ]]]

add_executable(reify ${header} ${source})
target_link_libraries(reify PRIVATE libreify libpotassco)
target_include_directories(reify PRIVATE
    "$<BUILD_INTERFACE:${CLINGO_SOURCE_DIR}/libclingo>")
set_target_properties(reify PROPERTIES FOLDER exe)

install(TARGETS reify RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

=== app/web/CMakeLists.txt ===
# [[[source: .
set(ide_source_group "Source Files")
set(source-group
    "${CMAKE_CURRENT_SOURCE_DIR}/main.cc")
source_group("${ide_source_group}" FILES ${source-group})
set(source
    ${source-group})
# ]]]

add_executable(web ${header} ${source})
target_link_libraries(web libclingo libclasp libluaclingo libpyclingo)
set_target_properties(web PROPERTIES FOLDER exe)
target_include_directories(web PRIVATE
    "$<BUILD_INTERFACE:${CLINGO_SOURCE_DIR}/libgringo>"
    "$<BUILD_INTERFACE:${CLASP_SOURCE_DIR}/app>")

set_target_properties(web PROPERTIES LINK_FLAGS "-s EXPORTED_FUNCTIONS='[\"_run\"]'")
set_target_properties(web PROPERTIES OUTPUT_NAME "clingo")

=== clasp/libpotassco/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)
project(LIB_POTASSCO VERSION 1.0 LANGUAGES CXX)
if (POLICY CMP0063)
	cmake_policy(SET CMP0063 NEW)
endif()
# enable folders in IDEs like Visual Studio
set_property(GLOBAL PROPERTY USE_FOLDERS ON)
include(GNUInstallDirs)
option(LIB_POTASSCO_BUILD_TESTS "whether or not to build tests"          OFF)
option(LIB_POTASSCO_BUILD_APP   "whether or not to build lpconvert tool" ON)
option(LIB_POTASSCO_INSTALL_LIB "whether or not to install libpotassco"  OFF)

set(include_dest  "potassco-${LIB_POTASSCO_VERSION}")
set(library_dest  "potassco-${LIB_POTASSCO_VERSION}")
set(cmake_dest    "potassco-${LIB_POTASSCO_VERSION}/cmake")

if (LIB_POTASSCO_INSTALL_LIB AND NOT CMAKE_INSTALL_LIBDIR)
	message(STATUS "LIBDIR no set - using lib")
	set(CMAKE_INSTALL_LIBDIR lib)
endif()

if (NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
	message(STATUS "No build type selected - using 'Release'")
	set(CMAKE_BUILD_TYPE "Release")
endif()

if (NOT MSVC)
	if (NOT CMAKE_ARCHIVE_OUTPUT_DIRECTORY)
		set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
	endif()
	if (NOT CMAKE_LIBRARY_OUTPUT_DIRECTORY)
		set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
	endif()
	if (NOT CMAKE_RUNTIME_OUTPUT_DIRECTORY)
		set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
	endif()
else()
    set(VC_RELEASE_LINK_OPTIONS /LTCG)
	SET(CMAKE_EXE_LINKER_FLAGS_RELEASE    "${CMAKE_EXE_LINKER_FLAGS_RELEASE}    ${VC_RELEASE_LINK_OPTIONS}")
	SET(CMAKE_MODULE_LINKER_FLAGS_RELEASE "${CMAKE_MODULE_LINKER_FLAGS_RELEASE} ${VC_RELEASE_LINK_OPTIONS}")
	SET(CMAKE_SHARED_LINKER_FLAGS_RELEASE "${CMAKE_SHARED_LINKER_FLAGS_RELEASE} ${VC_RELEASE_LINK_OPTIONS}")
	SET(CMAKE_STATIC_LINKER_FLAGS_RELEASE "${CMAKE_STATIC_LINKER_FLAGS_RELEASE} ${VC_RELEASE_LINK_OPTIONS}")
endif()

add_subdirectory(src)
if(LIB_POTASSCO_BUILD_TESTS)
	enable_testing()
	add_subdirectory(tests)
endif()
if(LIB_POTASSCO_BUILD_APP)
	add_subdirectory(app)
endif()

# optional doc target
find_package(Doxygen)
if(DOXYGEN_FOUND)
	set(doxyfile "${CMAKE_CURRENT_SOURCE_DIR}/doc/Doxyfile")
	add_custom_target(doc_potassco
		COMMAND ${DOXYGEN_EXECUTABLE} ${doxyfile}
		WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/doc"
		COMMENT "Generating documentation..."
		VERBATIM)
	set_target_properties(doc_potassco PROPERTIES FOLDER doc)
endif()

# export
configure_file(cmake/potassco-config-version.cmake.in
	${CMAKE_CURRENT_BINARY_DIR}/potassco-config-version.cmake
	@ONLY)
if(LIB_POTASSCO_INSTALL_LIB)
	install(FILES cmake/potassco-config.cmake ${CMAKE_CURRENT_BINARY_DIR}/potassco-config-version.cmake DESTINATION "${CMAKE_INSTALL_LIBDIR}/${cmake_dest}")
	install(EXPORT potassco DESTINATION "${CMAKE_INSTALL_LIBDIR}/${cmake_dest}")
endif()

=== examples/c/CMakeLists.txt ===
# [[[cog
#    import os
#    import os.path
#    import re
#    os.chdir(os.path.dirname(cog.inFile))
#    for root, dirnames, filenames in os.walk('.'):
#        for filename in filenames:
#            if re.match(r"^.*\.c$", filename):
#                name = filename[:-2]
#                cog.out("""
#                        add_executable({name} "${{CMAKE_CURRENT_SOURCE_DIR}}/{filname}")
#                        target_link_libraries({name} PRIVATE libclingo)
#                        set_target_properties({name} PROPERTIES FOLDER "exe/clingo-c-examples")
#                        """.format(name=name, filname=filename))
# ]]]

set(CMAKE_C_STANDARD 11)

add_executable(model "${CMAKE_CURRENT_SOURCE_DIR}/model.c")
target_link_libraries(model PRIVATE libclingo)
set_target_properties(model PROPERTIES FOLDER "exe/clingo-c-examples")

add_executable(version "${CMAKE_CURRENT_SOURCE_DIR}/version.c")
target_link_libraries(version PRIVATE libclingo)
set_target_properties(version PROPERTIES FOLDER "exe/clingo-c-examples")

add_executable(backend "${CMAKE_CURRENT_SOURCE_DIR}/backend.c")
target_link_libraries(backend PRIVATE libclingo)
set_target_properties(backend PROPERTIES FOLDER "exe/clingo-c-examples")

add_executable(control "${CMAKE_CURRENT_SOURCE_DIR}/control.c")
target_link_libraries(control PRIVATE libclingo)
set_target_properties(control PROPERTIES FOLDER "exe/clingo-c-examples")

add_executable(propagator "${CMAKE_CURRENT_SOURCE_DIR}/propagator.c")
target_link_libraries(propagator PRIVATE libclingo)
set_target_properties(propagator PROPERTIES FOLDER "exe/clingo-c-examples")

add_executable(symbolic-atoms "${CMAKE_CURRENT_SOURCE_DIR}/symbolic-atoms.c")
target_link_libraries(symbolic-atoms PRIVATE libclingo)
set_target_properties(symbolic-atoms PROPERTIES FOLDER "exe/clingo-c-examples")

add_executable(configuration "${CMAKE_CURRENT_SOURCE_DIR}/configuration.c")
target_link_libraries(configuration PRIVATE libclingo)
set_target_properties(configuration PROPERTIES FOLDER "exe/clingo-c-examples")

add_executable(statistics "${CMAKE_CURRENT_SOURCE_DIR}/statistics.c")
target_link_libraries(statistics PRIVATE libclingo)
set_target_properties(statistics PROPERTIES FOLDER "exe/clingo-c-examples")

add_executable(symbol "${CMAKE_CURRENT_SOURCE_DIR}/symbol.c")
target_link_libraries(symbol PRIVATE libclingo)
set_target_properties(symbol PROPERTIES FOLDER "exe/clingo-c-examples")

add_executable(ast "${CMAKE_CURRENT_SOURCE_DIR}/ast.c")
target_link_libraries(ast PRIVATE libclingo)
set_target_properties(ast PROPERTIES FOLDER "exe/clingo-c-examples")

add_executable(solve-async "${CMAKE_CURRENT_SOURCE_DIR}/solve-async.c")
target_link_libraries(solve-async PRIVATE libclingo)
set_target_properties(solve-async PROPERTIES FOLDER "exe/clingo-c-examples")

add_executable(theory-atoms "${CMAKE_CURRENT_SOURCE_DIR}/theory-atoms.c")
target_link_libraries(theory-atoms PRIVATE libclingo)
set_target_properties(theory-atoms PROPERTIES FOLDER "exe/clingo-c-examples")

# [[[end]]]

=== examples/cc/CMakeLists.txt ===
add_executable(cc-solve-iteratively "solve-iteratively.cc")
target_link_libraries(cc-solve-iteratively PRIVATE libclingo)
set_target_properties(cc-solve-iteratively PROPERTIES FOLDER "exe/clingo-cc-examples")

add_executable(cc-inject-terms "inject-terms.cc")
target_link_libraries(cc-inject-terms PRIVATE libclingo)
set_target_properties(cc-inject-terms PROPERTIES FOLDER "exe/clingo-cc-examples")

=== debian/changelog ===
gringo (5.2.2-5) unstable; urgency=medium

  * fix FTBFS with gringo-python3-utf8.patch
  * debian/rules: report ctest logs in case of error

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Mon, 05 Feb 2018 07:39:21 +0100

gringo (5.2.2-4) unstable; urgency=medium

  * setup build environment for python3
    + debian/control: setup Build-Depends for python3
    + debian/rules: force PYTHON_EXECUTABLE to /usr/bin/python3
  * FTBFS: dh_auto_test needs LD_LIBRARY_PATH for libclingo

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Sun, 04 Feb 2018 21:35:05 +0100

gringo (5.2.2-3) unstable; urgency=medium

  * add dep8 testsuite
    + debian/rules: build, run, and output upstream tests
    + debian/tests: add dep8 tests
  * debian/symbols: add ia64, update templinst archs

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Sun, 04 Feb 2018 09:22:41 +0100

gringo (5.2.2-2) unstable; urgency=medium

  * update debian/control and debian/compat
    + update Vcs-Git and Vcs-Browser for salsa
    + bump Standards-Version to 4.1.3
    + bump debhelper compatibility version to 11
  * debian/symbols: update amd64 symbols

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Sat, 03 Feb 2018 15:17:29 +0100

gringo (5.2.2-1) unstable; urgency=medium

  * New upstream version 5.2.2
  * drop upstream applied gringo-remove-wrong-assertion.patch
  * debian/symbols: add arm64 kfreebsd-amd64 kfreebsd-i386 symbols
    pkgkde-symbolshelper batchpatch -v 1

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Fri, 10 Nov 2017 08:08:58 +0100

gringo (5.2.1-4) unstable; urgency=medium

  * debian/symbols: fix FTBFS on armel

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Sat, 04 Nov 2017 14:55:24 +0100

gringo (5.2.1-3) unstable; urgency=medium

  * add patch from upstream commit 02c6d85 to fix wrong assertion
  * debian/control: Build-Depends to cmake >= 3.1.0

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Sat, 04 Nov 2017 11:14:23 +0100

=== debian/control ===
Source: gringo
Section: interpreters
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Thomas Krennwallner <tkren@kr.tuwien.ac.at>
Build-Depends: debhelper (>= 11),
 dpkg-dev (>= 1.16.1~),
 pkg-kde-tools,
 g++-7 (>= 7.2.0),
 cmake (>= 3.1.0),
 re2c,
 bison,
 liblua5.3-dev,
 python3,
 libpython3-dev
Standards-Version: 4.1.3
Vcs-Git: https://salsa.debian.org/science-team/gringo.git
Vcs-Browser: https://salsa.debian.org/science-team/gringo
Homepage: https://www.potassco.org/clingo/

Package: gringo
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: clasp
Replaces: clingo, iclingo
Conflicts: clingo, iclingo
Breaks:
 aspcud (<= 1.9.0-2),
 clasp (<< 3.2.1-1)
Description: grounding tools for (disjunctive) logic programs
 Current answer set solvers work on variable-free programs. Hence, a
 grounder is needed that, given an input program with first-order
 variables, computes an equivalent ground (variable-free) program.
 .
 This package contains the following tools:
 .
  - gringo: a grounder that, given an input program with first-order
    variables, computes an equivalent ground (variable-free) program in
    aspif format. Its output can be processed further with answer set
    solver clasp. Starting with gringo series 5, its output is no longer
    directly compatible with solvers like smodels or cmodels reading
    smodels format. Use lpconvert for translating aspif format to
    smodels format.
  - clingo: combines both gringo and clasp into a monolithic system.
    This way it offers more control over the grounding and solving
    process than gringo and clasp can offer individually: multi-shot
    solving.
  - lpconvert: converter between gringo's aspif and smodels format.
  - reify: small utility that reifies logic programs given in aspif
    format. It produces a set of facts, which can be processed further
    with gringo.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# gringo requires c++11 threads with 64bit __atomic_exchange, we need to
# link with libatomic on armel, powerpc, powerpcspe, m68k, mips, mipsel, and
# sh4, see also
# https://gcc.gnu.org/wiki/Atomic
# https://gcc.gnu.org/wiki/Atomic/GCCMM/LIbrary
arch = $(shell dpkg-architecture -qDEB_BUILD_ARCH | egrep -x "(armel|powerpc|powerpcspe|m68k|mips|mipsel|sh4)")

# use custom hardening config flags for compiling clasp
CONFIG=hardening
CONFIGPARMS = -DCMAKE_BUILD_TYPE=Release -DCMAKE_INSTALL_PREFIX=/usr -LAH -DCMAKE_SKIP_RPATH=YES -DCLINGO_MANAGE_RPATH=OFF -DLIB_POTASSCO_BUILD_APP=ON -DLIB_POTASSCO_BUILD_TESTS=ON -DCLASP_BUILD_APP=OFF -DCLASP_BUILD_TESTS=OFF -DCLASP_BUILD_EXAMPLES=OFF -DCLINGO_BUILD_EXAMPLES=ON -DCLINGO_BUILD_TESTS=ON -DPYTHON_EXECUTABLE:FILEPATH=/usr/bin/python3
TOPBUILDDIR = build/$(CONFIG)_mt
ROOTDIR = $(shell pwd)

#
# export CXXFLAGS and LDFLAGS for cmake
#
# add -O3 and NDEBUG and enable all hardening flags
# link with libatomic on architectures without built-in atomic
#
DEB_CXXFLAGS_MAINT_APPEND = -O3 -DNDEBUG
DEB_LDFLAGS_MAINT_APPEND =
ifeq ($(if $(arch),atomic), atomic)
	DEB_LDFLAGS_MAINT_APPEND += -latomic
endif

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

#
# export CPPFLAGS, CXXFLAGS, and LDFLAGS for scons
#
# default to -O3 -Wall -DNDEBUG and enable all hardening flags
#
DEB_CXXFLAGS_MAINT_APPEND = -O3 -Wall
DEB_CPPFLAGS_MAINT_APPEND = -DNDEBUG
DEB_LDFLAGS_MAINT_APPEND =
ifeq ($(if $(arch),atomic), atomic)
	DEB_LDFLAGS_MAINT_APPEND += -latomic
endif

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

# force g++-7
export CXX = g++-7
export CC = gcc-7
# inject CPPFLAGS to CXXFLAGS
CXXFLAGS += $(CPPFLAGS)

%:
	dh $@ --with pkgkde_symbolshelper

# configure with cmake
override_dh_auto_configure:
	dh_auto_configure --builddirectory=$(TOPBUILDDIR) -- $(CONFIGPARMS)

# build binaries in $(TOPBUILDDIR)
override_dh_auto_build:
	dh_auto_build --builddirectory=$(TOPBUILDDIR)

override_dh_auto_clean:
	dh_auto_clean --builddirectory=$(TOPBUILDDIR)

# run and output test results
override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	dh_auto_test --builddirectory=$(TOPBUILDDIR) -- -e LD_LIBRARY_PATH="$(ROOTDIR)/$(TOPBUILDDIR)/bin:$(LD_LIBRARY_PATH)" &&\
		{ EXIT_CODE=$$? ; echo "Exit $$EXIT_CODE" ; test -d $(TOPBUILDDIR)/Testing/Temporary && tail -n +1 -v -- $(TOPBUILDDIR)/Testing/Temporary/* ; exit $$EXIT_CODE ; } ||\
		{ EXIT_CODE=$$? ; echo "Exit $$EXIT_CODE" ; test -d $(TOPBUILDDIR)/Testing/Temporary && tail -n +1 -v -- $(TOPBUILDDIR)/Testing/Temporary/* ; exit $$EXIT_CODE ; }
endif

# install CHANGES.md as changelog
override_dh_installchangelogs:
	dh_installchangelogs CHANGES.md

override_dh_shlibdeps:
	dh_shlibdeps -l$(shell pwd)/$(TOPBUILDDIR)/bin

=== debian/watch ===
# watch control file for uscan

# Compulsory line, this is a version 3 file
version=3

opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/gringo-$1\.tar\.gz/ \
  https://github.com/potassco/gringo/tags .*/v?(\d\S+)\.tar\.gz

## gringo 5.2.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -8,8 +8,8 @@
     cmake_policy(SET CMP0063 NEW)
 endif()
 if (NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
-	message(STATUS "No build type selected - using 'Release'")
-	set(CMAKE_BUILD_TYPE "Release")
+    message(STATUS "No build type selected - using 'Release'")
+    set(CMAKE_BUILD_TYPE "Release")
 endif()
 
 include(GNUInstallDirs)
@@ -40,15 +40,18 @@
 CMAKE_DEPENDENT_OPTION(CLINGO_BUILD_LUA_SHARED "build luaclingo library shared"   OFF "NOT CLINGO_BUILD_STATIC"  OFF)
 
 option(PYCLINGO_USER_INSTALL "install the python module in the user's site directory" ON)
+option(PYCLINGO_DYNAMIC_LOOKUP "do not link to python library and pass linker option `-undefined link_dynamic`" ${APPLE})
 CMAKE_DEPENDENT_OPTION(PYCLINGO_USE_INSTALL_PREFIX "install the python module under the install prefix" OFF "NOT PYCLINGO_USER_INSTALL" OFF)
 
 set(CLINGO_CLINGOPATH "" CACHE STRING "global search directories for clingo's include statement")
+set(CLINGO_USE_LIB OFF CACHE BOOL "advanced option to build python and lua modules against an existing libclingo")
 
 mark_as_advanced(CLINGO_BUILD_WEB)
 mark_as_advanced(CLINGO_BUILD_STATIC)
 mark_as_advanced(CLINGO_BUILD_SHARED)
 mark_as_advanced(CLINGO_BUILD_PY_SHARED)
 mark_as_advanced(CLINGO_BUILD_LUA_SHARED)
+mark_as_advanced(CLINGO_USE_LIB)
 
 # workaround to set custom ar and ranlib
 if (CLINGO_CMAKE_AR)
@@ -65,11 +68,10 @@
 if (CLINGO_MANAGE_RPATH)
     set(CMAKE_SKIP_BUILD_RPATH FALSE)
     set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
-    set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
     set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
-    list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/lib" isSystemDir)
+    list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_FULL_LIBDIR}" isSystemDir)
     if ("${isSystemDir}" STREQUAL "-1")
-        set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
+        set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_FULL_LIBDIR}")
     endif()
 endif()
 
@@ -99,6 +101,7 @@
 #       that searching for the python libraries finds the matching libraries for the default python interpreter
 #       python is also used to run the tests
 find_package(PythonInterp)
+add_library(Pyclingo::Pyclingo INTERFACE IMPORTED)
 if (CLINGO_BUILD_WITH_PYTHON)
     if (CLINGO_REQUIRE_PYTHON)
         find_package(PythonLibs REQUIRED)
@@ -107,8 +110,12 @@
     endif()
     if(PYTHONLIBS_FOUND)
         add_library(Python::Python INTERFACE IMPORTED)
-        set_property(TARGET Python::Python PROPERTY INTERFACE_LINK_LIBRARIES "${PYTHON_LIBRARIES}")
         set_property(TARGET Python::Python PROPERTY INTERFACE_INCLUDE_DIRECTORIES "${PYTHON_INCLUDE_DIRS}")
+        if (PYCLINGO_DYNAMIC_LOOKUP)
+            set_property(TARGET Pyclingo::Pyclingo PROPERTY INTERFACE_LINK_LIBRARIES "${PYTHON_LIBRARIES}")
+        else()
+            set_property(TARGET Python::Python PROPERTY INTERFACE_LINK_LIBRARIES "${PYTHON_LIBRARIES}")
+        endif()
     endif()
 endif()
 if (CLINGO_BUILD_WITH_LUA)
@@ -134,12 +141,19 @@
 enable_testing()
 
 # NOTE: assumes that submodule has been initialized
-set(clingo_library_targets libclingo libgringo libpotassco libclasp libreify)
 set(CLASP_BUILD_APP ${CLINGO_BUILD_APPS} CACHE BOOL "")
-add_subdirectory(clasp)
-add_subdirectory(libreify)
-add_subdirectory(libgringo)
-add_subdirectory(libclingo)
+if (CLINGO_USE_LIB)
+    set(clingo_library_targets)
+    add_library(libclingo INTERFACE IMPORTED)
+    set_property(TARGET libclingo PROPERTY INTERFACE_INCLUDE_DIRECTORIES "${CLINGO_SOURCE_DIR}/libclingo")
+    set_property(TARGET libclingo PROPERTY INTERFACE_LINK_LIBRARIES "clingo")
+else()
+    set(clingo_library_targets libclingo libgringo libpotassco libclasp libreify)
+    add_subdirectory(clasp)
+    add_subdirectory(libreify)
+    add_subdirectory(libgringo)
+    add_subdirectory(libclingo)
+endif()
 if (PYTHONLIBS_FOUND)
     add_subdirectory(libpyclingo)
     list(APPEND clingo_library_targets libpyclingo)
@@ -152,7 +166,7 @@
 else()
     add_library(libluaclingo INTERFACE IMPORTED)
 endif()
-if (CLINGO_BUILD_APPS)
+if (CLINGO_BUILD_APPS AND NOT CLINGO_USE_LIB)
     add_subdirectory(app/reify)
     add_subdirectory(app/gringo)
     add_subdirectory(app/clingo)

=== Makefile ===
LUA_DIR=$(HOME)/local/opt/lua-5.3.4-js
BUILD_TYPE=debug
CC=/usr/bin/cc
CXX=/usr/bin/c++

all: build/$(BUILD_TYPE)
	cd build/$(BUILD_TYPE) && cd $$(pwd -P) && cmake .
	$(MAKE) -C build/$(BUILD_TYPE)

build/$(BUILD_TYPE):
	mkdir -p build/$(BUILD_TYPE)
	current="$$(pwd -P)" && cd build/$(BUILD_TYPE) && cd "$$(pwd -P)" && cmake \
		-DCMAKE_BUILD_TYPE=$(BUILD_TYPE) \
		-DCMAKE_VERBOSE_MAKEFILE=On \
		-DCMAKE_C_COMPILER="${CC}" \
		-DCMAKE_CXX_COMPILER="${CXX}" \
		-DCLINGO_BUILD_TESTS=On \
		-DCLASP_BUILD_TESTS=On \
		-DLIB_POTASSCO_BUILD_TESTS=On \
		-DCLINGO_BUILD_EXAMPLES=On \
		"$${current}"

%:: build/$(BUILD_TYPE) FORCE
	cd build/$(BUILD_TYPE) && cd $$(pwd -P) && cmake .
	$(MAKE) -C build/$(BUILD_TYPE) $@

test: build/$(BUILD_TYPE)
	cd build/$(BUILD_TYPE) && cd $$(pwd -P) && cmake .
	$(MAKE) -C build/$(BUILD_TYPE)
	$(MAKE) -C build/$(BUILD_TYPE) $@ CTEST_OUTPUT_ON_FAILURE=TRUE

web:
	mkdir -p build/web
	current="$$(pwd -P)" && cd build/web && cd "$$(pwd -P)" && source $$(which emsdk_env.sh) && emcmake cmake \
		-DCLINGO_BUILD_WEB=On \
		-DCLINGO_BUILD_WITH_PYTHON=Off \
		-DCLINGO_BUILD_WITH_LUA=On \
		-DCLINGO_BUILD_SHARED=Off \
		-DCLASP_BUILD_WITH_THREADS=Off \
		-DCMAKE_VERBOSE_MAKEFILE=On \
		-DCMAKE_BUILD_TYPE=release \
		-DCMAKE_CXX_FLAGS="-std=c++11 -Wall -s DISABLE_EXCEPTION_CATCHING=0" \
		-DCMAKE_CXX_FLAGS_RELEASE="-Os -DNDEBUG" \
		-DCMAKE_EXE_LINKER_FLAGS="" \
		-DCMAKE_EXE_LINKER_FLAGS_RELEASE="" \
		-DLUA_LIBRARIES=$(LUA_DIR)/lib/liblua.a \
		-DLUA_INCLUDE_DIR=$(LUA_DIR)/include \
		"$${current}"
	$(MAKE) -C build/web web

glob:
	find app libclingo libgringo libreify libluaclingo libpyclingo -name CMakeLists.txt | xargs ./cmake/glob-paths.py

FORCE:

.PHONY: all test web glob FORCE

=== debian/changelog ===
gringo (5.2.3-2ubuntu1) disco; urgency=medium

  * Rename async keyword argument to _async.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 02 Nov 2018 07:42:54 +0100

gringo (5.2.3-2build1) disco; urgency=medium

  * No-change rebuild to build for python3.7 as the default.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 31 Oct 2018 12:34:47 +0000

gringo (5.2.3-2) unstable; urgency=medium

  * debian/symbols: batchpatch symbols

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Tue, 03 Jul 2018 06:23:44 +0200

gringo (5.2.3-1) unstable; urgency=medium

  * New upstream version 5.2.3
  * debian/watch: force three-digit version
  * debian/control: bump Standards-Version to 4.1.4
  * debian/TODO.Debian: refresh TODO list
  * gringo-makefile.patch: drop Makefile
  * debian/symbols: update amd64 symbols

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Sat, 30 Jun 2018 13:27:28 +0200

gringo (5.2.2-6) unstable; urgency=medium

  * Team upload
  * Added build-dependency python3-distutils in order to fix FTBFS. Thanks
    to Adrian Bunk for the patch (closes: #896791)
  * Added debian/gbp.conf with pristine-tar=True

 -- Ralf Treinen <treinen@debian.org>  Thu, 03 May 2018 08:30:23 +0200

=== debian/control ===
--- 
+++ 
@@ -12,8 +12,9 @@
  bison,
  liblua5.3-dev,
  python3,
- libpython3-dev
-Standards-Version: 4.1.3
+ libpython3-dev,
+ python3-distutils
+Standards-Version: 4.1.4
 Vcs-Git: https://salsa.debian.org/science-team/gringo.git
 Vcs-Browser: https://salsa.debian.org/science-team/gringo
 Homepage: https://www.potassco.org/clingo/
